/****************************************************************************
* VisualBoyAdvance 1.7.2
*
* Nintendo GameCube Joypad Wrapper
****************************************************************************/
#include <gccore.h>
#include <stdio.h>

#define VBA_BUTTON_A		1
#define VBA_BUTTON_B		2
#define VBA_BUTTON_SELECT	4
#define VBA_BUTTON_START	8
#define VBA_RIGHT		16
#define VBA_LEFT		32
#define VBA_UP			64
#define VBA_DOWN		128
#define VBA_BUTTON_R		256
#define VBA_BUTTON_L		512
#define VBA_SPEED		1024
#define VBA_CAPTURE		2048

u32
NGCPad()
{
  u32             res = 0;
  short           p;
  signed char     x,
  y;
  int             padcal = 90;
  float           t;

  p = PAD_ButtonsHeld(0);
  x = PAD_StickX(0);
  y = PAD_StickY(0);

  if (x * x + y * y > padcal * padcal)
    {
      if (x > 0 && y == 0)
        res |= VBA_RIGHT;
      if (x < 0 && y == 0)
        res |= VBA_LEFT;
      if (x == 0 && y > 0)
        res |= VBA_UP;
      if (x == 0 && y < 0)
        res |= VBA_DOWN;

      /*** Recalc left / right ***/
      t = (float) y / x;
      if (t >= -2.41421356237 && t < 2.41421356237)
        {
          if (x >= 0)
            res |= VBA_RIGHT;
          else
            res |= VBA_LEFT;
        }

      /*** Recalc up / down ***/
      t = (float) x / y;
      if (t >= -2.41421356237 && t < 2.41421356237)
        {
          if (y >= 0)
            res |= VBA_UP;
          else
            res |= VBA_DOWN;
        }
    }

  if (p & PAD_BUTTON_A)
    res |= VBA_BUTTON_A;

  if (p & PAD_BUTTON_B)
    res |= VBA_BUTTON_B;

  if (p & PAD_TRIGGER_Z)
    res |= VBA_BUTTON_SELECT;

  if (p & PAD_BUTTON_START)
    res |= VBA_BUTTON_START;

  if (p & PAD_BUTTON_UP)
    res |= VBA_UP;

  if (p & PAD_BUTTON_DOWN)
    res |= VBA_DOWN;

  if (p & PAD_BUTTON_LEFT)
    res |= VBA_LEFT;

  if (p & PAD_BUTTON_RIGHT)
    res |= VBA_RIGHT;

  if (p & PAD_TRIGGER_L)
    res |= VBA_BUTTON_L;

  if (p & PAD_TRIGGER_R)
    res |= VBA_BUTTON_R;

  if ((res & 48) == 48)
    res &= ~16;
  if ((res & 192) == 192)
    res &= ~128;

  return res;
}
